/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.clearquest;

import java.io.IOException;
import java.io.InputStream;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;



public class CQWrapper {
	
	static String host;
	static int port;
	static int timeout;

	public void setHost(String hostName){
		host = hostName;
	}
	public void setPort(int portNumber){
		port = portNumber;
	}
	public void setTimeout(int timeOut){
		timeout = timeOut;
	}
	
	public CQWrapper(){
		host = "localhost";
		port = 7070;
		timeout = 2000;
	}
	
	public String getQueryResult(String xml) throws IOException,InterruptedException {
		
		String fileName = "./getEntitiesWithSocket.pl";
		String perl = "cqperl";
		String queryResult = "ERROR!";
		
		Runtime.getRuntime().exec(perl + " " + fileName);
	 
		//definisce la socket verso perl
	    InetAddress addr = InetAddress.getByName(host);
	    
        // crea l'indirizzo socket
        SocketAddress socketAddr = new InetSocketAddress(addr, port);
	    Socket sock = new Socket();
	    for(int k=0;k<5;k++){
	    	try {
	    		sock.connect(socketAddr,timeout);
	    	}
	    	catch (IOException e){
	    		Thread.sleep(2000);
	    	}
	    }
        
        
        //System.out.println("STATO: " + sock.isConnected());
        
        InputStream perlOut = sock.getInputStream();
        //OutputStream
        
        if(perlOut.available()>0){
        	 
        	byte a[] = new byte[perlOut.available()];
        	
        	perlOut.read(a);
        	
        	//System.out.println("SERVER TELLS-->" + new String(a));
        }
        
        
        // invio l'xml
        sock.getOutputStream().write(xml.getBytes());
        sock.getOutputStream().flush();
        // richiedo la chiusura del socket server
        sock.getOutputStream().write("END\n".getBytes());
        sock.getOutputStream().flush();
        
        
        // recupero l'xml prodotto
        for(int i=0; i<30; i++){
        	int avaible = perlOut.available(); 
        	if(avaible>0){
        		byte a[] = new byte[perlOut.available()];
        		perlOut.read(a);
        		queryResult = new String(a);
        		//System.out.println("SERVER TELLS-->" + queryResult);
        		break;
        	}
        	Thread.sleep(1000);
        }       
        //disconnect
        perlOut.close();
        sock.close();
        return queryResult;
	}
}
 